{
open Util
open Dparser

(*
** Keyword hashtable
*)

let string_of lb = (Lexing.lexeme lb) 

let lexicon = Hashtbl.create 211
let _ = List.iter 
    (fun (key, token) -> Hashtbl.add lexicon key token)
    [ 
      ("LOOKUP_IDS_SYMBOL_OF_INT", SET_IDS_SYMBOL_OF_INT) ; 
	    ("ADD_MAP_NOTE", ADD_MAP_NOTE); 
      ("ACTION_IF", ACTION_IF) ;
      ("ADD_CRE_ITEM", ADD_CRE_ITEM) ;
      ("ADD_GAME_NPC", PATCH_GAM) ;
      ("ADD_KIT", ADD_KIT) ;
      ("ADD_KNOWN_SPELL", ADD_KNOWN_SPELL) ;
      ("ADD_MUSIC", ADD_MUSIC) ;
      ("ADD_PROJECTILE", ADD_PROJECTILE) ;
      ("ADD_STATE_TRIGGER", ADD_STATE_TRIGGER) ;
      ("ADD_STORE_ITEM", ADD_STORE_ITEM);
      ("ADD_TRANS_ACTION", ADD_TRANS_ACTION) ;
      ("ADD_TRANS_TRIGGER", ADD_TRANS_TRIGGER) ;
      ("ALLOW_MISSING", ALLOW_MISSING) ; 
      ("ALWAYS", ALWAYS) ; 
      ("APPEND", APPEND); 
      ("APPENDI", APPENDI); 
      ("APPEND_COL", APPEND_COL); 
      ("APPEND_FILE", APPEND_FILE); 
      ("APPEND_EARLY", APPEND_EARLY); 
      ("APPLY_BCS_PATCH", APPLY_BCS_PATCH) ;
      ("APPLY_BCS_PATCH_OR_COPY", APPLY_BCS_PATCH_OR_COPY) ;
      ("ASK_EVERY_COMPONENT", ASK_EVERY_COMPONENT); 
      ("AT_EXIT", AT_EXIT); 
      ("AT_INTERACTIVE_EXIT", AT_INTERACTIVE_EXIT); 
      ("AT_INTERACTIVE_UNINSTALL", AT_INTERACTIVE_UNINSTALL); 
      ("AT_UNINSTALL", AT_UNINSTALL); 
      ("AUTHOR", AUTHOR); 
      ("AUTO_TRA", AUTO_TRA); 
      ("A_B_P", APPLY_BCS_PATCH) ;
      ("A_S_T", ADD_STATE_TRIGGER) ;
      ("A_T_T", ADD_TRANS_TRIGGER) ;
      ("BACKUP", BACKUP) ;
      ("BEGIN", BEGIN) ;
      ("BUT_ONLY_IF_IT_CHANGES", BUT_ONLY_IF_IT_CHANGES); 
      ("CHAIN", CHAIN3);
      ("CHAIN2", CHAIN2);
      ("CHAIN3", CHAIN3);
      ("COMPILE", COMPILE);
      ("COMPILE_BAF_TO_BCS", COMPILE_BAF_TO_BCS);
      ("COMPILE_D_TO_DLG", COMPILE_D_TO_DLG);
      ("COPY", COPY);
      ("COPY_EXISTING", COPY_EXISTING);
      ("COPY_EXISTING_REGEXP", COPY_EXISTING_REGEXP);
      ("COPY_RANDOM", COPY_RANDOM);
      ("COPY_TRANS", COPY_TRANS);
      ("DECOMPILE_BCS_TO_BAF", DECOMPILE_BCS_TO_BAF);
      ("DECOMPILE_DLG_TO_D", DECOMPILE_DLG_TO_D);
      ("DELETE_BYTES", DELETE_BYTES);
      ("DEPRECATED", DEPRECATED); 
      ("DESCRIBE_ITEM", DESCRIBE_ITEM) ; 
      ("DESIGNATED", DESIGNATED); 
      ("DO", DO) ;
      ("ELSE", ELSE) ;
      ("END", END) ;
      ("EQUIP", EQUIP);
      ("EXIT", EXIT) ;
      ("EXTEND",EXTEND_BOTTOM) ; 
      ("EXTEND_BOTTOM", EXTEND_BOTTOM) ; 
      ("EXTEND_BOTTOM_REGEXP", EXTEND_BOTTOM_REGEXP);
      ("EXTEND_TOP", EXTEND_TOP) ;
      ("EXTEND_TOP_REGEXP", EXTEND_TOP_REGEXP);
      ("EXTERN", EXTERN) ;
      ("EVALUATE_BUFFER", EVALUATE_BUFFER) ; 
      ("FAIL", FAIL);
      ("FLAGS", FLAGS);
      ("FOR", FOR) ; 
      ("FORBID_COMPONENT", FORBID_COMPONENT) ;
      ("FORBID_FILE", FORBID_FILE) ; 
      ("GLOB", GLOB); 
      ("GOTO", GOTO) ;
      ("IF", IF) ;
      ("IF_EVAL", IF_EVAL) ;
      ("IF_SIZE_IS", IF_SIZE_IS) ;
      ("INNER_ACTION", INNER_ACTION) ;
      ("INNER_PATCH", INNER_PATCH) ;
      ("INNER_PATCH_FILE", INNER_PATCH_FILE) ;
      ("INSERT_BYTES", INSERT_BYTES);
      ("INSERT_FILE", INSERT_FILE);
      ("INSTALL_BY_DEFAULT", INSTALL_BY_DEFAULT) ;
      ("INTERJECT", INTERJECT);
      ("INTERJECT_COPY_TRANS", INTERJECT_COPY_TRANS);
      ("INTERJECT_COPY_TRANS2", INTERJECT_COPY_TRANS2);
      ("I_C_T", INTERJECT_COPY_TRANS);
      ("I_C_T2", INTERJECT_COPY_TRANS2);
      ("I_S_I", IF_SIZE_IS) ;
      ("JOURNAL", JOURNAL) ;
      ("LANGUAGE", LANGUAGE) ;
      ("MENU_STYLE", MENU_STYLE) ;
      ("MKDIR", MKDIR) ;
      ("NO_LOG_RECORD", NO_LOG_RECORD) ; 
      ("PATCH_GAM", PATCH_GAM) ;
      ("PATCH_IF", PATCH_IF) ;
      ("PATCH_PRINT", PATCH_PRINT);
      ("SPRINT", SPRINT);
      ("SNPRINT", SNPRINT);
      ("PRINT", PRINT);
      ("RANDOM", RANDOM);
      ("RANDOM_SEED", RANDOM_SEED);
      ("PATCH_RANDOM_SEED", PATCH_RANDOM_SEED);
      ("READ_2DA_ENTRY", READ_2DA_ENTRY) ;
      ("COUNT_2DA_ROWS", COUNT_2DA_ROWS) ;
      ("READ_ASCII", READ_ASCII);
      ("READ_STRREF", READ_STRREF);
      ("READ_BYTE", READ_BYTE) ;
      ("READ_SBYTE", READ_SBYTE) ;
      ("READ_SSHORT", READ_SSHORT) ;
      ("READ_LONG", READ_LONG) ;
      ("READ_SHORT", READ_SHORT) ;
      ("REMOVE_KNOWN_SPELL", REMOVE_KNOWN_SPELL) ;
      ("REPLACE", REPLACE) ;
      ("REPLACE_ACTION_TEXT", REPLACE_ACTION_TEXT) ;
      ("REPLACE_ACTION_TEXT_PROCESS", REPLACE_ACTION_TEXT_PROCESS) ;
      ("REPLACE_ACTION_TEXT_PROCESS_REGEXP", REPLACE_ACTION_TEXT_PROCESS_REGEXP) ;
      ("REPLACE_ACTION_TEXT_REGEXP", REPLACE_ACTION_TEXT_REGEXP) ;
      ("REPLACE_BCS_BLOCK", REPLACE_BCS_BLOCK) ;
      ("REPLACE_BCS_BLOCK_REGEXP", REPLACE_BCS_BLOCK_REGEXP) ;
      ("REPLACE_EVALUATE", REPLACE_EVALUATE) ;
      ("REPLACE_SAY", REPLACE_SAY) ;
      ("REPLACE_STATE_TRIGGER", REPLACE_STATE_TRIGGER) ;
      ("REPLACE_TEXTUALLY", REPLACE_TEXTUALLY) ;
      ("REPLACE_TRIGGER_TEXT", REPLACE_TRIGGER_TEXT) ;
      ("REPLACE_TRIGGER_TEXT_REGEXP", REPLACE_TRIGGER_TEXT_REGEXP) ;
      ("REPLY", REPLY) ;
      ("REQUIRE_COMPONENT", REQUIRE_COMPONENT) ;
      ("REQUIRE_FILE", REQUIRE_FILE) ;
      ("REQUIRE_PREDICATE", REQUIRE_PREDICATE) ;
      ("R_A_T", REPLACE_ACTION_TEXT) ;
      ("R_B_B", REPLACE_BCS_BLOCK) ;
      ("R_B_B_RE", REPLACE_BCS_BLOCK_REGEXP) ;
      ("R_S_T", REPLACE_STATE_TRIGGER) ;
      ("R_T_T", REPLACE_TRIGGER_TEXT) ;
      ("SAY", SAY) ;
      ("SAY_EVALUATED", SAY_EVALUATED) ;
      ("SCRIPT_STYLE", SCRIPT_STYLE) ;
      ("SET", SET); 
      ("SET_2DA_ENTRY", SET_2DA_ENTRY) ;
      ("SET_2DA_ENTRY_LATER", SET_2DA_ENTRY_LATER) ;
      ("SET_2DA_ENTRIES_NOW", SET_2DA_ENTRIES_NOW) ;
      ("SET_WEIGHT", SET_WEIGHT) ;
      ("SOLVED_JOURNAL", SOLVED_JOURNAL) ;
      ("STRING_COMPARE", STRING_EQUAL) ;
      ("STRING_COMPARE_CASE", STRING_EQUAL_CASE) ;
      ("STRING_COMPARE_REGEXP", STRING_MATCHES_REGEXP) ;
      ("STRING_MATCHES_REGEXP", STRING_MATCHES_REGEXP) ;
      ("STRING_CONTAINS_REGEXP", STRING_CONTAINS_REGEXP) ;
      ("STRING_SET", STRING_SET) ;
      ("STRING_SET_RANGE", STRING_SET_RANGE) ;
      ("STR_CMP", STRING_EQUAL) ;
      ("SUBCOMPONENT", SUBCOMPONENT) ;
      ("SUB_COMPONENT", SUBCOMPONENT) ;
      ("THEN", THEN) ;
      ("TWOHANDED", TWOHANDED); 
      ("UNINSTALL", UNINSTALL) ;
      ("UNLESS", UNLESS) ;
      ("UNSOLVED_JOURNAL", UNSOLVED_JOURNAL) ;
      ("USING", USING) ;
      ("WEIGHT", WEIGHT) ;
      ("WHILE", WHILE) ;
      ("WRITE_ASCII", WRITE_ASCII) ;
      ("WRITE_BYTE", WRITE_BYTE) ;
      ("WRITE_EVALUATED_ASCII", WRITE_EVALUATED_ASCII) ;
      ("WRITE_FILE", WRITE_FILE) ;
      ("WRITE_LONG", WRITE_LONG) ;
      ("WRITE_SHORT", WRITE_SHORT) ;

      (* predicates *) 
      ("FILE_EXISTS", FILE_EXISTS ) ;
      ("FILE_MD5", FILE_MD5 ) ;
      ("FILE_EXISTS_IN_GAME", FILE_EXISTS_IN_GAME ) ;
      ("FILE_SIZE", FILE_SIZE ) ;
      ("FILE_CONTAINS", FILE_CONTAINS ) ;
      ("FILE_CONTAINS_EVALUATED", FILE_CONTAINS_EVALUATED ) ;
      ("AND", AND) ;
      ("OR", OR) ;
      ("NOT", NOT) ;

      ("BAND", BAND) ;
      ("BOR", BOR) ;
      ("BNOT", BNOT) ;
      ("BXOR", BXOR) ;
      ("BLSL", BLSL) ;
      ("BLSR", BLSR) ;
      ("BASR", BASR) ;
    ] 

(*
** Buffer processor
*)
 



} 

let decdigit = ['0'-'9']
let octdigit = ['0'-'7']
let letter = ['a' - 'z' 'A'-'Z']

let blank = [' ' '\012' '\r']

rule initial = parse 	
  "/*"  { adj lexbuf ; let _ = comment lexbuf in initial lexbuf}
| "//"  { adj lexbuf ; endline lexbuf }
| blank	{ adj lexbuf ; initial lexbuf}
| '\t'  { tab (); initial lexbuf }
| '\n'  { newline (); initial lexbuf }
| '('   { adj lexbuf ; LPAREN } 
| ')'   { adj lexbuf ; RPAREN } 
| '?'   { adj lexbuf ; QUESTION } 
| ':'   { adj lexbuf ; COLON } 
| ';'   { adj lexbuf ; SEMICOLON } 
| '+'   { adj lexbuf ; PLUS } 
| '-'   { adj lexbuf ; MINUS } 
| '*'   { adj lexbuf ; TIMES } 
| "**"   { adj lexbuf ; TIMESTIMES } 
| '/'   { adj lexbuf ; DIVIDE } 
| '='   { adj lexbuf ; EQUALS } 
| '>'   { adj lexbuf ; GT } 
| '<'   { adj lexbuf ; LT } 
| '+'   { adj lexbuf ; PLUS } 
| '^'   { adj lexbuf ; STRING_CONCAT } 

| "+="  { adj lexbuf ; PLUS_EQUALS } 
| "-="  { adj lexbuf ; MINUS_EQUALS } 
| "*="  { adj lexbuf ; TIMES_EQUALS } 
| "/="  { adj lexbuf ; DIVIDE_EQUALS } 
| "|="  { adj lexbuf ; OR_EQUALS } 
| "&="  { adj lexbuf ; AND_EQUALS } 
| "<<=" { adj lexbuf ; BLSL_EQUALS }
| ">>=" { adj lexbuf ; BLSR_EQUALS }

| "!"   { adj lexbuf ; NOT } 
| "&"  { adj lexbuf ; BAND } 
| "|"  { adj lexbuf ; BOR }   
| "^^" { adj lexbuf ; BXOR } 
| "&&"  { adj lexbuf ; AND } 
| "||"  { adj lexbuf ; OR } 
| "<<"  { adj lexbuf ; BLSL } 
| ">>"  { adj lexbuf ; BLSR } 

| ">="   { adj lexbuf ; GTE } 
| "<="   { adj lexbuf ; LTE } 
| "=="  { adj lexbuf ; EQUALSEQUALS } 
| "!="  { adj lexbuf ; NOTEQUALS } 
| "["[^']']*"]" { str_adj lexbuf ; SOUND(strip (string_of lexbuf)) }
| "~"[^'~']*"~"  
| '"'[^'"']*'"'  
| '%'[^'%']*'%'  { str_adj lexbuf ; STRING(strip (string_of lexbuf)) } 
| "~" { adj lexbuf; BNOT } 
| ['0'-'9''A'-'Z''a'-'z''_']['0'-'9''A'-'Z''a'-'z''#''_''-''.']* { 
    adj lexbuf ; try Hashtbl.find lexicon (string_of lexbuf) 
    with _ -> STRING(string_of lexbuf) }
| '#'['-']?['0'-'9']+ { adj lexbuf ;
      let str = string_of lexbuf in
      let str = String.sub str 1 ((String.length str) - 1) in
      STRING_REF((int_of_string str)) }
| '!'['-']?['0'-'9']+ { adj lexbuf ;
      let str = string_of lexbuf in
      let str = String.sub str 1 ((String.length str) - 1) in
      FORCED_STRING_REF((int_of_string str)) }
| '@'['-']?['0'-'9']+ { adj lexbuf ;
      let str = string_of lexbuf in
      let str = String.sub str 1 ((String.length str) - 1) in
      TRANS_REF((int_of_string str)) }
| "~~~~~" { adj lexbuf ; let buf = Buffer.create 255 in widestring buf lexbuf } 
| "<<<<<<<<" [' ']* ([^'\n''\r']* as name) ('\r'?)'\n' { 
  adj lexbuf ; 
  let buf = Buffer.create 10240 in 
  inlined name buf lexbuf } 
| eof   { EOF }
| _	{ lex_error (Printf.sprintf "invalid character [%s]" (string_of
lexbuf)) }
and comment = parse 	
      "*/"	{ adj lexbuf ; () }
|     '\n'      { newline (); comment lexbuf }
|     "/*"      { adj lexbuf ; let _ = comment lexbuf in comment lexbuf } 
|     eof       { lex_error "unterminated comment" } 
|     _ 	{ adj lexbuf ; comment lexbuf }
and widestring buf = parse
|     "~~~~~"    { adj lexbuf ; STRING(Buffer.contents buf) }
|     eof        { lex_error "unterminated ~~~~~ string" }
|     '\n'       { newline (); Buffer.add_char buf '\n';widestring buf lexbuf}
|     _          { adj lexbuf ; let str = string_of lexbuf in
                   Buffer.add_string buf str ; widestring buf lexbuf } 
and inlined name buf = parse 
|     ">>>>>>>>"{ adj lexbuf ; 
                  INLINED_FILE(name,(Buffer.contents buf)) }
|     eof       { lex_error "unterminated inlined file" } 
|     '\n'      { newline (); Buffer.add_char buf '\n' ; 
                  inlined name buf lexbuf } 
|     _         { adj lexbuf ; 
                  let str = string_of lexbuf in
                  Buffer.add_string buf str ;
                  inlined name buf lexbuf } 
and endline = parse 
        '\n' 			{ newline (); initial lexbuf}
|	_			{ adj lexbuf ; endline lexbuf}
|       eof                     { EOF }
